#2921 closed defect (fixed)

libdl assumes constructors in ELF are a ".ctors" section.

Reported by: Chris Johns Owned by: Chris Johns
Priority: normal Milestone:
Component: lib/dl Version: 5
Severity: normal Keywords:
Cc: Blocked By:
Blocking:

Description

The RTL libdl loader assumes constructors are in a section called '.ctor' and destructors are in '.dtor'. The section can have any name. The section type needs to be used.

Change History (3)

comment:1 Changed on Mar 23, 2017 at 1:03:28 AM by Chris Johns

Milestone: 4.11.24.11.3

The 4.11.2 milestone is closing.

comment:2 Changed on Feb 5, 2018 at 5:10:39 AM by Chris Johns

Milestone: 4.11.3
Version: 4.115

This bug is present on the master branch and needs to be fixed there. If the change is suitable for back porting a new ticket can be opened and a suitable 4.11 milestone can be assigned.

comment:3 Changed on Feb 8, 2019 at 11:08:31 PM by Chris Johns <chrisj@…>

Resolution: fixed
Status: assignedclosed

In 4408603/rtems:

libdl: Fix the support for constructors and desctructors.

  • Fix the handling of pending objects.
  • Add a constructor flags in objects to track then being called.

Closes #2921

Note: See TracTickets for help on using tickets.